/* Code generated by Engee
 * Model name: pwm_chart.engee
 * Code generator: release-1.0.21
 * Date: Thu May  2 06:18:57 2024
 */

#include "stdint.h"
#include "pwm_chart.h"

/* External outputs */
Ext_pwm_chart_Y pwm_chart_Y;

/* Block states */
Ext_pwm_chart_S pwm_chart_S;

typedef struct CFunction_cfunc_symbols_t {
	double in;
} CFunction_cfunc_symbols_t;

static void CFunction_cfunc_init() {
	// Проверка того, что код компилируется для Arduino-совместимой платы
	#ifdef Arduino_h
	    // Определение GPIO № 13 (LED), как выходного пина
	    pinMode(13, OUTPUT);
	    // Инициализация последовательного порта, со скоростью передачи 115 200 бод
	    Serial.begin(115200);
	#endif
}
static void CFunction_cfunc(CFunction_cfunc_symbols_t * cfunc_symbols) {
	double in = cfunc_symbols->in;
	//

	/*
	Код для циклического выполнения на целевом устройстве
	(Arduino-совместимые платы) 
	*/

	// проверка того, что код компилируется для Arduino-совместимой платы
	#ifdef Arduino_h
	    // установка продолжительности импульса ШИМ на выходе 13 (LED)
	    analogWrite(13, in);
	    // вывод в последовательный порт продолжительности импульса ШИМ
	    Serial.println(in); 
	#endif
}

static void CFunction_cfunc_term() {

}
/* Model initialize function */
void pwm_chart_init() {
	pwm_chart_S.Chart_cnt = 0;
	pwm_chart_S.Chart_out = 0;
	pwm_chart_S.Chart_state = -1;
	CFunction_cfunc_init();
}

/* Model terminate function */
void pwm_chart_term() {
	CFunction_cfunc_term();
}

/* Model step function */
void pwm_chart_step() {

	/* Chart: /Chart incorporates:
	 */
	double Chart;
	double Chart_p1;
	{
		/* Chart's output variables: */
		double cnt = pwm_chart_S.Chart_cnt;
		double out = pwm_chart_S.Chart_out;

		int Chart_state = pwm_chart_S.Chart_state;
		int Chart_selector;
		if (Chart_state == 0) {
			if (cnt < 200) {
				out = 51;
cnt = cnt + 1;
				Chart_selector = 1;
			}
			else if (cnt >= 200 && cnt < 400) {
				out = 102;
cnt = cnt + 1;
				Chart_selector = 1;
			}
			else if (cnt >= 400 && cnt < 600) {
				out = 153;
cnt = cnt + 1;
				Chart_selector = 1;
			}
			else if (cnt >= 600 && cnt < 800) {
				out = 204;
cnt = cnt + 1;
				Chart_selector = 1;
			}
			else if (cnt >= 800 && cnt < 1000) {
				out = 255;
cnt = cnt + 1;
				Chart_selector = 1;
			}
			else if (cnt >= 1000) {
				cnt = 0;
out = 0;
				Chart_selector = 1;
			}
			else {
				goto Chart_done;
			}
		}
		else {
			Chart_selector = 1;
		}
		switch (Chart_selector) {
			case 1:
			{
				Chart_state = 0;
				goto Chart_done;
				break;
			}
		}
Chart_done:
		pwm_chart_S.Chart_state = Chart_state;
		/* Chart's output variables: */
		Chart = pwm_chart_S.Chart_cnt = cnt;
		Chart_p1 = pwm_chart_S.Chart_out = out;
	}
	/* CFunction: /C Function incorporates:
	 *  Chart: /Chart
	 */
	CFunction_cfunc_symbols_t CFunction_cfunc_symbols = {
		Chart_p1,
	};
	CFunction_cfunc(&CFunction_cfunc_symbols);
	/* Outport: /Cnt incorporates:
	 *  Chart: /Chart
	 */
	pwm_chart_Y.Cnt = Chart;

}
